import { Http, Response } from 'angular2/http';
import { OnInit } from 'angular2/core';
import { Observable } from 'rxjs/Rx';
import { SDLogger } from '../logger/logger';
import { Credentials } from './credentials';
export declare class AuthenticationService implements OnInit {
    private http;
    private logger;
    AUTH_COOKIE: string;
    private authenticated;
    private credentials;
    private locationWatcher;
    private expires;
    private intervalId;
    private expiresTimerId;
    private COOKIE_EXPIRATION_DAYS;
    constructor(http: Http, logger: SDLogger);
    authenticate(username: string, password: string): Observable<Credentials>;
    recover(email: string): Observable<Response>;
    getCredentials(): Credentials;
    logout(): void;
    subscribe(onNext: (value: any) => void, onThrow?: (exception: any) => void, onReturn?: () => void): any;
    isAuthenticated(): boolean;
    private _getCredentials();
    private _emitAuthStatus(success);
    private _startExpiresTimer(seconds);
    private _clearCredentials();
    private _storeCredentials(c);
    ngOnInit(): void;
}
