var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('angular2/core');
var router_1 = require("angular2/router");
var logger_1 = require('../logger/logger');
var authentication_service_1 = require('./authentication.service');
var ProtectedDirective = (function () {
    function ProtectedDirective(logger, authService, router, location) {
        var _this = this;
        this.logger = logger;
        this.authService = authService;
        this.router = router;
        this.location = location;
        this.sub = null;
        if (!authService.isAuthenticated()) {
            this.location.replaceState('/'); // clears browser history so they can't navigate with back button
            this.router.navigate(['Login']);
            this.logger.info('protection applied!');
        }
        this.sub = this.authService.subscribe(function (val) {
            if (!val.isAuthenticated()) {
                _this.logger.info('protection subsctiption applied!');
                _this.location.replaceState('/'); // clears browser history so they can't navigate with back button
                _this.router.navigate(['Login']); // tells them they've been logged out (somehow)
            }
        });
    }
    ProtectedDirective.prototype.ngOnDestroy = function () {
        if (this.sub != null) {
            this.sub.unsubscribe();
        }
    };
    ProtectedDirective = __decorate([
        core_1.Directive({
            selector: '[protected]',
            providers: []
        }), 
        __metadata('design:paramtypes', [logger_1.SDLogger, authentication_service_1.AuthenticationService, router_1.Router, router_1.Location])
    ], ProtectedDirective);
    return ProtectedDirective;
})();
exports.ProtectedDirective = ProtectedDirective;
//# sourceMappingURL=protected.directive.js.map