import {Directive, OnDestroy} from 'angular2/core';

import {ROUTER_DIRECTIVES, Router, Location} from "angular2/router";
import {SDLogger} from '../logger/logger';
import {AuthenticationService} from './authentication.service';
@Directive({
    selector: '[protected]',
    providers:[]
})
export class ProtectedDirective implements OnDestroy {
    private sub:any = null;

    constructor(private logger: SDLogger, private authService:AuthenticationService, private router:Router, private location:Location) {
        if (!authService.isAuthenticated()) {
            this.location.replaceState('/'); // clears browser history so they can't navigate with back button
            this.router.navigate(['Login']);
            this.logger.info('protection applied!')
        }

        this.sub = this.authService.subscribe((val) => {
            if (!val.isAuthenticated()) {
              this.logger.info('protection subsctiption applied!')
                this.location.replaceState('/'); // clears browser history so they can't navigate with back button
                this.router.navigate(['Login']); // tells them they've been logged out (somehow)
            }
        });
    } 

    ngOnDestroy() {
        if (this.sub != null) {
            this.sub.unsubscribe();
        }
    }
}