import {Injectable} from 'angular2/core';
// Angular 2 service for logging is not currently available, so we use loglevel for now.
// for more details about loglevel go to https://www.npmjs.com/package/loglevel
let log = require('loglevel');

/**
 * Wrapper for third party logger library. 
 */
@Injectable()
export class SDLogger {

	constructor() {}

	/**
	 * Disables all logging below the given level.
	 * @param level  Log Level to be applied in this order: trace, debug, info, warn, error
	 */
	setLevel(level: string) {
		log.setLevel(level);
	}

	/**
	 * @param msg  Message output in the console.
	 */
	trace(msg: string) {
		log.trace(msg);
	}

	/**
	 * @param msg  Message output in the console.
	 */
	debug(msg: string) {
		log.debug(msg);
	}

	/**
	 * @param msg  Message output in the console.
	 */
	info(msg: string) {
		log.info(msg);
	}

	/**
	 * @param msg  Message output in the console.
	 */
	warn(msg: string) {
		log.warn(msg);
	}

	/**
	 * @param msg  Message output in the console.
	 */
	error(msg: string) {
		log.error(msg);
	}
}
